<?php

namespace App\Controller;

use App\Container;
use App\Router\Request\IRequest;
use App\Router\Response\Response;
use Shared\Attributes\Route;
use Twig\Environment;
use Data\Core\Preferences;
use Data\Core\User;
use Shared\Log;
use PHPMailer\PHPMailer\PHPMailer;

class AuthController extends BaseController
{
    
    private Preferences $preference;
    private User $user;

    public function __construct(){
        $this->preference = new Preferences();
        $this->user = new User("test", "Antoine", "Dieu", "dieu@paradis.univers", "test", "Dieu", 1.82, 70.9);
    }

    #[Route(path: '/register', name: 'inscription', methods: ['GET'])]
    public function register(): Response
    {
        return $this->render('./page/register.html.twig',[
            'css' => $this->preference->getCookie()
        ]);
    }

    #[Route(path: '/sign-up', name: 'sign-up', methods: ['POST'])]
    public function signup(?string $username,?string $nom, ?string $prenom ,?string $mail,?string $confPassword, ?string $password , ?string $sexe, ?IRequest $request): Response
    {
        $user = new User($username, $nom, $prenom, $mail, $password,$confPassword, $sexe, 18.6, 19.3);
        return $this->render('./page/login.html.twig',[
            'css' => $this->preference->getCookie()
        ]);
    }

    #[Route(path: '/login', name: 'connexion', methods: ['GET'])]
    public function login(): Response
    {
        return $this->render('./page/login.html.twig',[
            'css' => $this->preference->getCookie()
        ]);
    }

    #[Route(path: '/login-in', name: 'login-in', methods: ['POST'])]
    public function login_in(?string $username, ?string $mdp ,IRequest $request): Response
    {
        if($this->user->getUsername() == $username && $this->user->getMotDePasse() == $mdp){
            return $this->render('./page/home.html.twig',[
                'css' => $this->preference->getCookie(),
                'pp' => "test2",
                'user' => $this->user->getNom()." ".$this->user->getPrenom(),
                'role' => "Athlète",
                'friendship' => [],
                'analyzes' => [],
                'mails' => [],
                'users' => [],
                'infoUser' => [],
                'exos' => [],
                'member' => []
            ]);
        }
        else{
            return $this->render('./page/login.html.twig',[
                'css' => $this->preference->getCookie()
            ]);
        }
    }
    
    function connexion(){
        $model = new ModelVisitor();
        if(!isset($_POST['pseudo']) || !isset($_POST['password'])) throw new Exception(" some wrong with credentials !!!!!");
        $log=Validation::clean_string($_POST['pseudo']);
        $mdp=Validation::clean_string($_POST['password']);
            if(ModelUser::login($log, $mdp)){
                UserControler::displayView();
            }
        
    }

    #[Route(path: '/password-missing', name: 'password-missing', methods: ['GET'])]
    public function pass(): Response
    {
        return $this->render('./page/password.html.twig',[
            'css' => $this->preference->getCookie()
        ]);
    }

    #[Route(path: '/password-send', name: 'password-send', methods: ['POST'])]
    public function password(?string $email, IRequest $req): Response
    {
        $mail = new PHPMailer();
        $mail->isSMTP();
        $mail->SMTPDebug = 0;
        $mail->Host = 'smtp.gmail.com';
        $mail->Port = 465;
        $mail->SMTPAuth = true;
        $mail->SMTPSecure = 'ssl';
        $mail->Username = 'hearttrack3@gmail.com';
        $mail->Password = 'zjuh pvae mkvq hqgc';
        $mail->setFrom('hearttrack3@gmail.com', 'HeartTrack');
        $mail->addAddress($email, '');
        $mail->Subject = 'Reinitialisation de votre mot de passe - HeartTrack';
        $mail->Body = 'Wallah c\'est cool en vrai';
        if(!$mail->send()){
            return $this->render('./page/password.html.twig',[
                'css' => $this->preference->getCookie()
            ]);
        }
        else{
            return $this->render('./page/login.html.twig',[
                'css' => $this->preference->getCookie()
            ]);
        }

    }  
}

?>